

#    MIDAS Access Client  for the  TDRIAccess service

package require MIDASAccessClient    ;#   load default support procedures

global TDRIAccessServerHost TDRIAccessServerPort

if {[info exists TDRIAccessServerHost] == 0} then {set TDRIAccessServerHost localhost}
if {[info exists TDRIAccessServerPort] == 0} then {set TDRIAccessServerPort 8015}

variable uri "urn:TDRIAccessServer"
variable proxy "http://$TDRIAccessServerHost:$TDRIAccessServerPort/TDRIAccessServer"

proc TDRIAccessClient_Configure {} {
   global  TDRIAccessServerHost TDRIAccessServerPort
   variable proxy

   set proxy "http://$TDRIAccessServerHost:$TDRIAccessServerPort/TDRIAccessServer"

   foreach method [info procs TDRIAccessClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create TDRIAccessClient__Init -proxy $proxy -uri $uri -timeout 1000 \
     -name Init \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create TDRIAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name Verbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TDRIAccessClient__ReadControl -proxy $proxy -uri $uri -timeout 1000 \
     -name ReadControl \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create TDRIAccessClient__WriteControl -proxy $proxy -uri $uri -timeout 1000 \
     -name WriteControl \
     -params {Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create TDRIAccessClient__Status -proxy $proxy -uri $uri -timeout 1000 \
     -name Status \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create TDRIAccessClient__Version -proxy $proxy -uri $uri -timeout 1000 \
     -name Version \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


package provide TDRIAccessClient 1.0
