

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable Present 
    variable CorePresent
    variable SegmentPresent 
    variable FpgaList
    variable FpgaIDs 
    variable Fpga 
    variable ShortTimeOut 5000

    variable Digitizer      -1
    variable NumDigitizer    0
    variable DigitizerList   {}

    variable Detector      -1
    variable DetectorList   {}

    variable Crystal      -1
    variable CrystalList   {}

    variable Segment      -1
    variable SegmentList   {}

    variable Offset

    for {set i 1} {$i <= 7} {incr i} {set Offset($i) 0}

    set FpgaList {"Use Probe Hardware"}
    set FpgaIDs {}       ;# 0 1 2 3 8 9 10 11 12
    set Fpga "Use Probe Hardware"

#   access procedures

    set CorePresent 0        ;#   for current digitizer
    set SegmentPresent 0     ;#   for current digitizer
    for {set i 0} {$i <= 12} {incr i} {set Present($i) 0}     ;# index is fpga ID


   proc  show_variables {} {
       variable Digitizer
       variable Fpga 
       variable Offset
       variable Detector
       variable Crystal
       variable Segment

             InsertLog "Digitizer=$Digitizer; Fpga=$Fpga; Detector=$Detector; Crystal=$Crystal; Segment=$Segment"
             for {set i 1} {$i <= 7} {incr i} {InsertLog "Offset($i)=[set Offset($i)]"}
   }

   proc do_parameters {} {
        variable cgidata
        variable Offset
        variable LogFlag

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {
               Offset*_value  {
                   set n [string range $name 6 6]
                   set Offset($n) $value
                   if {$LogFlag == 1} {InsertLog "Offset($n) = $value"}
               }

               Detector -
               Crystal -
               Segment -
               Fpga -
               Digitizer  {
                    variable $name
                    set $name $value
                    if {$LogFlag == 1} {InsertLog "$name = $value"}
               }
            }
        }
   }

   proc click-selectDetector {} {
       variable Digitizer
       variable Fpga 
       variable Detector
       variable Crystal
       variable Segment
        variable LogFlag

   upvar #0 AGATADigitizerAccessServer_Detector2Digitizer Detector2Digitizer
       variable Segment2Fpga

       set Digitizer [set Detector2Digitizer([set Detector]_[set Crystal])]
       if {$LogFlag == 1} {InsertLog "Digitizer = $Digitizer"}
       set Fpga [set Segment2Fpga($Segment)]
       if {$LogFlag == 1} {InsertLog "Fpga = $Fpga"}
   }

   proc click-selectDigitizer {} {
       variable Digitizer
       variable Fpga 
       variable Detector
       variable Crystal
       variable Segment
        variable LogFlag

    upvar #0 AGATADigitizerAccessServer_Digitizer2Detector Digitizer2Detector
       variable Fpga2Segment

       set Detector [first [split [set Digitizer2Detector($Digitizer)] _]]
       if {$LogFlag == 1} {InsertLog "Detector = $Detector"}
       set Crystal [second [split [set Digitizer2Detector($Digitizer)] _]]
       if {$LogFlag == 1} {InsertLog "Crystal = $Crystal"}
       set Segment [set Fpga2Segment($Fpga)]
       if {$LogFlag == 1} {InsertLog "Segment = $Segment"}
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]
               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   PROBE    {do_parameters; click-probe}

                   PROM     {click-readprom}

                   SELECTF  {do_parameters; click-selectDigitizer; do_UpdateOffsets}
                   SELECTD  {do_parameters; click-selectDetector; do_UpdateOffsets}

                   SETUP2     {click-setupall}
                   SETUP1     {click-setupdigitizer}
                   SETUP0     {click-setupfpga}

                   CHECK2     {click-checkall}
                   CHECK1     {click-checkdigitizer}

                   OFFSET*    {do_parameters; click-offset [string range $w 6 end]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

    EnumerateDigitizers

}   ;# end of if {$started == 0}




