
set applications {"MIDAS Data Analysis" "MIDAS Data Acquisition" MTsort Ultra exogam GREAT "GREAT-SAGE" Merge RISING Prisma \
    GRT TUDA TIARA megha TAS Afrodite FERA meis vxi vme camac laser theory user \
       "user application" "Httpd+SOAP" 1394 8080 CAEN VF48 MDI2 V1724 V1729 LyrTech PorgamRays Nucam2 AGATA Quix ML403 VSSP "Gassiplex Acquisition" "MEIS Controls" "Diagnostics & Tests" default}

proc select-application {which} {
  global env

  if {$env(platform) == "unix"} then {set J ":"} else {set J ";"}

  set debug 0
  set ll [split $which -]
  if {[last $ll] == "debug"} then {
    set debug 1
    set which [join [lreplace $ll end end] -]
  }

  set base $env(MIDASBASE)
  if {![info exists env(MIDASsortBase)]} then {set env(MIDASsortBase) [file join $env(MIDASBASE) MIDASsort]}

  set core [file join $env(MIDASsortBase) tcl]$J[file join $base tcl]

  switch $which {

     MIDASsort -
     "MIDAS Data Analysis" {
        set tclpath $core
        set env(MIDASExcludeCommonLib) 1
        set env(MIDASExcludeSOAPLib) 1
        set env(MIDASExcludeMIDASLib) 1
        set env(MIDASExcludePackageLib) 1
     }

     "MIDAS Data Acquisition" {
        set tclpath [file join $base MIDAS_Acq tcl]$J[file join $base Data_Acq tcl]$J[file join $base SOAP tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     "Diagnostics & Tests" {
        set tclpath [file join $base Diagnostics tcl]$J[file join $base SOAP tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J$core
        set env(PATH) [file join $base Diagnostics bin_$env(OpSys)]$J$env(PATH)
     }

     MTsort {
        set tclpath [file join $base MTsort tcl]$J[file join $base tcl]
     }

     Ultra {
        set tclpath [file join $base Ultra tcl]$J[file join $base MIDAS_Acq tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     exogam {
        set tclpath [file join $base exogam tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     HV {
        set tclpath [file join $base highVoltage tcl]$J[file join $base tcl]
     }

     megha {
        set tclpath [file join $base megha tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     Afrodite {
        set tclpath [file join $base Afrodite tcl]$J[file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base MTsort tcl]$J$core
     }

     TAS {
        set tclpath [file join $base TAS tcl]$J[file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base MTsort tcl]$J$core
     }

     FERA {
        set tclpath [file join $base fera tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base MTsort tcl]$J$core
     }

     TUDA {
        set tclpath [file join $base TUDA tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     TIARA {
        set tclpath [file join $base TIARA tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J$core
     }

     laser {
        set tclpath [file join $base laser tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }
     meis {
        set tclpath [file join $base meis tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base SOAP tcl]$J[file join $base tcl]

        set meispath [file join $base meis bin_$env(OpSys)]
        set env(PATH) $meispath$J$env(PATH)
        puts stdout "program search path now includes $meispath"
     }

     GREAT {
        set tclpath [file join $base GREAT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base highVoltage tcl]$J[file join $base tcl]
     }

     GREAT-SAGE {
        set tclpath [file join $base GREAT_SAGE tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base highVoltage tcl]$J[file join $base tcl]
     }

     Merge {
        set tclpath [file join $base Merge tcl]$J[file join $base Data_Acq tcl]$J[file join $base tcl]
     }

     GREATEB {
        set tclpath [file join $base GREAT EventBuilder tcl]$J[file join $base MTsort tcl]$J[file join $base GREAT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base tcl]
        switch $env(os)  {
           SunOS   {
               set env(PATH) [file join $base GREAT EventBuilder bin_SunOS]:[file join $base MTsort bin_SunOS]:$env(PATH)
               set env(LD_LIBRARY_PATH) [file join $base GREAT EventBuilder lib_SunOS]:[file join $base MTsort lib_SunOS]:$env(LD_LIBRARY_PATH)
           }
           Linux   {
               set env(PATH) [file join $base GREAT EventBuilder bin_Linux]:[file join $base MTsort bin_Linux]:$env(PATH)
               set env(LD_LIBRARY_PATH) [file join $base GREAT EventBuilder lib_Linux]:[file join $base MTsort lib_Linux]:$env(LD_LIBRARY_PATH)
           }
           default {puts stderr "not available for platform $env(platform)"}
        }
     }

     RISING {
        set tclpath [file join $base RISING tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base tcl]
     }

     Prisma {
        set tclpath [file join $base Prisma tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J[file join $base TclHttpd tcl]$J[file join $base SOAP tcl]$J$core
     }

     vxi {
        set tclpath [file join $base vxi tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     1394 {
        set tclpath [file join $base 1394 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J$core
     }

     8080 {
        set tclpath [file join $base 8080 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J$core
     }

     vme {
        set tclpath [file join $base vme tcl]$J[file join $base Data_Acq tcl]$J$core
     }

     camac {
        set tclpath [file join $base camac tcl]$J[file join $base Data_Acq tcl]$J$core
     }
          
     GRT {
        set tclpath [file join $base GRT tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     VF48 {
        set tclpath [file join $base VF48 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     MDI2 {
        set tclpath [file join $base MDI2 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     V1724 {
        set tclpath [file join $base V1724 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     V1729 {
        set tclpath [file join $base V1729 tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     PorgamRays {
        set tclpath [file join $base PorgamRays tcl]$J[file join $base Data_Acq tcl]$J[file join $base SOAP tcl]$J$core
     }

     Nucam2 {
        set tclpath [file join $base Nucam2 tcl]$J[file join $base Data_Acq tcl]$J[file join $base SOAP tcl]$J$core
     }

     LyrTech {
        set tclpath [file join $base LyrTech tcl]$J[file join $base SOAP tcl]$J[file join $base Data_Acq tcl]$J$core
     }

     Quix {
        set tclpath [file join $base Quix tcl]$J[file join $base SOAP tcl]$J[file join $base Data_Acq tcl]$J$core
     }

     ML403 {
        set tclpath [file join $base ML403 tcl]$J[file join $base SOAP tcl]$J[file join $base Data_Acq tcl]$J$core
     }

     VSSP {
        set tclpath [file join $base VSSP tcl]$J[file join $base SOAP tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
     }

     GAS -
     "Gassiplex Acquisition" {
        set tclpath [file join $base GAS tcl]$J[file join $base SOAP tcl]$J[file join $base Data_Acq tcl]$J[file join $base vme tcl]$J$core
        set env(ServerAccessVersion) 2
     }

     CAEN {
        set tclpath [file join $base CAEN tcl]$J[file join $base Data_Acq tcl]$J[file join $base SOAP tcl]$J[file join $base vme tcl]$J[file join $base MTsort tcl]$J$core
     }

     AGATA {
        set tclpath [file join $base AGATA tcl]$J[file join $base SOAP tcl]$J$core
     }

     theory {
        set tclpath [file join $base theory tcl]$J[file join $base tcl]
     }

     user {
        set tclpath [file join $env(HOME) tcl]$J[file join $base user tcl]$J[file join $base tcl]
     }

     user_application -
     "user application" {
        set tclpath [file join $env(HOME) MidasApplication tcl]$J[file join $base user tcl]$J[file join $base tcl]
     }

     "Httpd+SOAP" {
        set tclpath [file join $base TclHttpd tcl]$J[file join $base SOAP tcl]$J[file join $base tcl]
     }

     MEIS_Controls -
     "MEIS Controls" {
        set tclpath [file join $base MEISControls tcl]$J[file join $base SOAP tcl]$J[file join $base tcl]
     }

     Test {
        set tclpath [file join $base Test tcl]$J[file join $base MIDAS_Acq tcl]$J[file join $base Data_Acq tcl]$J[file join $base vxi tcl]$J[file join $base vme tcl]$J[file join $base camac tcl]$J$core
     }

     default {
        set tclpath $core
     }
  }

  if {$debug} then {
    set tclpath [file join $env(HOME) tcl]$J$tclpath
    puts stdout "Debugging $which"
  }

  set env(TCLPATH) $tclpath

}
